package com.zksy.controller.info;

import cn.hutool.core.date.DateTime;
import com.zksy.info.domain.EArchivesAdministration;
import com.zksy.info.service.EArchivesAdministrationService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 员工档案管理控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/earchivesAdministration")
@Api(tags = "员工档案管理",description = "员工档案管理desc")
public class EArchivesAdministrationController {
    @Autowired
    private EArchivesAdministrationService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "员工档案管理查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize,String workNumber,String fullName, String type){
        return AjaxResult.success(service.findByPage(pageNum, pageSize,workNumber,fullName, type));
    }
    @GetMapping("/getEAdminLicenseInfoList")
    @ApiOperation(value = "员工档案管理查询")
    public AjaxResult getEAdminLicenseInfoList(String workNumber,String fullName,String type){
        return AjaxResult.success(service.getEArchivesAdministrationList(workNumber,fullName,type));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询员工档案管理")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "员工档案管理保存")
    public AjaxResult save(@RequestBody EArchivesAdministration eAdminLicenseInfo) {
        return service.save(eAdminLicenseInfo) ? AjaxResult.success(eAdminLicenseInfo) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "员工档案管理修改")
    public AjaxResult update(@RequestBody EArchivesAdministration eAdminLicenseInfo) {
        eAdminLicenseInfo.setUpdateTime(LocalDateTime.now());
        return service.updateById(eAdminLicenseInfo) ? AjaxResult.success(eAdminLicenseInfo) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "员工档案管理删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EArchivesAdministration.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String contactName,String contactDepartment,String contactMobile) {
        ExcelExportUtil.exportExcel(response,service.getEArchivesAdministrationList(contactName,contactDepartment,contactMobile), EArchivesAdministration.class, "员工档案信息","员工档案信息");
    }

}
